//==================================================================
//Trubetskoy Alex,  March 2004
//==================================================================
using System;
using System.Collections;

namespace Graph
{
	/// <summary>
	/// Summary description for Class.
	/// </summary>
	public class CalcExpr
	{
		int iLxm = 0;                   //index of the lexema string
		Stack stack = new Stack();      //stack for calculation
		bool valid;                     //if there was no calculate exceptions

		public CalcExpr()
		{
			// TODO: Add constructor logic here
		}

		bool isOperator(Lxm lxm) {
			return (lxm.type == "op" || lxm.op == 'f');
		}

		bool isOperand(Lxm lxm) {
			return (lxm.type == "x" || lxm.type == "n");
		}

		double executeOp(Lxm op, double x) {
			Lxm resLxm = new Lxm();
			resLxm.type = "n";
			double oprnd1, oprnd2, res = 0;

			Lxm lxm2 = (Lxm)stack.Pop();
			if(lxm2.type == "x") oprnd2 = x;
			else oprnd2 = lxm2.num;

			if(op.op == 'f') {
				unchecked {
					switch(op.type) {
						case "sin":  res = Math.Sin(oprnd2); break;
						case "cos":  res = Math.Cos(oprnd2); break;
						case "ln": {
							if(oprnd2 > 0) res = Math.Log(oprnd2);
							else {res = 0; valid = false;}
							break;
						}
						case "sqrt": {
							if(oprnd2 >= 0) res = Math.Sqrt(oprnd2);
							else {res = 0; valid = false;}
							break;
						}
					}
					resLxm.num = res;
				}
			}
			else {
				Lxm lxm1 = (Lxm)stack.Pop();
				if(lxm1.type == "x") oprnd1 = x;
				else oprnd1 = lxm1.num;

				unchecked {
					switch (op.op) {
						case '+': res = oprnd1 + oprnd2; break;
						case '-': res = oprnd1 - oprnd2; break;
						case '*': res = oprnd1 * oprnd2; break;
						case '/': {
							if(oprnd2 != 0) res = oprnd1 / oprnd2;
							else {res = 0; valid = false;}
							break;
						}
					}
					resLxm.num = res;
				}
			}
			stack.Push(resLxm);
			return res;
		}

		public Lxm executeExpr(ArrayList lxms, double x) {
			Lxm curLxm;
			iLxm = 0;
			valid = true;
			while(iLxm < lxms.Count) {
				curLxm = (Lxm)lxms[iLxm++];
				if(isOperand(curLxm))
					stack.Push(curLxm);
				else
				if(isOperator(curLxm))
					executeOp(curLxm, x);
			}
			curLxm = (Lxm)stack.Pop();
			if(lxms.Count == 1 && curLxm.type == "x")
			    curLxm.num = x;
			if(!valid) curLxm.type = "invalid";
			else curLxm.type = "valid";
			return curLxm;
		}
	}
}
