//==================================================================
//Trubetskoy Alex,  March 2004
//==================================================================
using System;
using System.Collections;

namespace Graph
{
	/// <summary>
	/// Summary description for Lxm.
	/// </summary>
	public struct Lxm {
		public string type;    //type of the lexema
		public double num;     //value (if lexema is a number)
		public char op;        //operation (if lexema ia an operation)

		public override string ToString() {
			if(type == "n")  return num.ToString();
			else
			if(type == "op") return op.ToString();
			else return type;
		}
	}

	/// <summary>
	/// Summary description for Class.
	/// </summary>
	public class Ppn
	{
		ArrayList outLxms = new ArrayList();
		string inStr = "";       //the input string
		int iin = 0;             //index of the input string
		bool wasNum = false;     //flag is used while converting
		char curc;               //the current character
		Lxm curLxm;              //the current lexema
		int countBr = 0;         //count of brackets

		public Ppn(string str) {
			inStr = str;
		}

		Lxm getNxtLxm() {
			Lxm lxm = new Lxm();
			string curStr = "";

			if(curc >= 'a' && curc <= 'z') {
				if(wasNum) {
					wasNum = false;
					throw (new Exception("Syntax error! 1"));
				}
				while(curc>='a' && curc<='z') {
					curStr += curc;
					nxtChar();
					if(curStr == "sin" || curStr == "cos"
					   || curStr == "ln" || curStr == "sqrt") {
						lxm.type = curStr;
						lxm.op = 'f';
						break;
					}
				}
				if(curStr.Length == 1 && curStr == "x") {
					lxm.type = "x";
				}
				else {
					if(lxm.op != 'f')
						throw (new Exception("Syntax error! 2"));
				}
			}
			else
			if((curc >= '0' && curc <= '9') || curc == '.') {
				string num = "";
				num += curc;
				nxtChar();
				while((curc>='0' && curc<='9') || curc=='.') {
					num += curc;
					nxtChar();
				}
				lxm.type = "n";
				lxm.num = Double.Parse(num);
				wasNum = true;
			}
			else {
				wasNum = false;
				if(curc=='(') {
					lxm.type = "ob";     //opening bracket
					++countBr;
					nxtChar();
				}
				else
				if(curc==')') {
					lxm.type = "cb";     //closing bracket
					--countBr;
					nxtChar();
				}
				else
				if(curc=='+' || curc=='-' || curc=='*' || curc=='/') {
					lxm.type = "op";     //operation
					lxm.op = curc;
					nxtChar();
				}
				else
				if(curc == '!') lxm.op = ' ';  //end of input string
				else
					throw (new Exception("Syntax error! 3"));
			}
			curLxm = lxm;
			return lxm;
		}

		char nxtChar() {
			if(iin < inStr.Length) {
				curc = inStr[iin++];
			}
			else curc = '!';
			return curc;
		}

		void P() {
			try {
				getNxtLxm();
				if(curLxm.type == "op")
					throw (new Exception("Syntax error! 4"));
				E();
			}
			catch(Exception e) {throw e;}
		}

		void E() {
            try {
				T();
				while(curLxm.op == '+' || curLxm.op == '-') {
					Lxm temp = curLxm;
					getNxtLxm();
					T();
					outLxms.Add(temp);
				}
			}
			catch(Exception e) {throw e;}
		}

		void T() {
			try {
				F();
				while(curLxm.op == '*' || curLxm.op == '/') {
					Lxm temp = curLxm;
					getNxtLxm();
					F();
					outLxms.Add(temp);
				}
			}
			catch(Exception e) {throw e;}
		}
		
		void F() {
			 try {
				 if(curLxm.op != 'f') {
					 M();
				 }
				 while(curLxm.op == 'f') {
					 Lxm temp = curLxm;
					 getNxtLxm();
					 M();
					 outLxms.Add(temp);
				 }
			 }
			 catch(Exception e) {throw e;}
		}

		void M() {
			 try {
				 if(curLxm.type == "ob") {
					 getNxtLxm();
					 E();
					 if(curLxm.type != "cb")
						 throw (new Exception("Syntax error! 5"));
					 else getNxtLxm();
				 }
				 else
				 if(curLxm.type == "x" || curLxm.type == "n") {
					 outLxms.Add(curLxm);
					 getNxtLxm();
				 }
				 else
					 throw (new Exception("Syntax error! 6"));
			 }
			 catch(Exception e) {throw e;}
		}

		public ArrayList convert() {
			 iin = countBr = 0;
			 nxtChar();
			 try {
				 P();
				 if(iin != inStr.Length || countBr != 0)
					 throw (new Exception("Syntax error! 7"));
				 return outLxms;
			 }
			 catch(Exception e) {throw e;}
		}
	}
}