//==================================================================
//Trubetskoy Alex,  March 2004
//==================================================================
using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Graph
{
	/// <summary>
	/// Summary description for WinForm.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Panel panelGraph;
		private System.Windows.Forms.TextBox tbFunc;
		private System.Windows.Forms.Label labelFunc;
		private System.Windows.Forms.Label labelYequals;
		private System.Windows.Forms.Button btnPaint;
		private System.Windows.Forms.Button btClear;
		private System.Windows.Forms.MainMenu mainMenu;
		private System.Windows.Forms.MenuItem miFile;
		private System.Windows.Forms.MenuItem miExit;
		private System.Windows.Forms.MenuItem miAction;
		private System.Windows.Forms.MenuItem miPaint;
		private System.Windows.Forms.MenuItem miIncScale;
		private System.Windows.Forms.MenuItem miDecScale;
		private System.Windows.Forms.MenuItem miClear;
		private System.Windows.Forms.MenuItem miHelp;
		private System.Windows.Forms.MenuItem miAbout;

		ArrayList funcs = new ArrayList();    //storage for input strings
		Point scale = new Point(16, 16);         //current scale

		public MainForm()
		{
			// Required for Windows Form Designer support
			InitializeComponent();
			// TODO: Add any constructor code after InitializeComponent call
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose (bool disposing)
		{
			if (disposing) {
				if (components != null) {
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.panelGraph = new System.Windows.Forms.Panel();
			this.tbFunc = new System.Windows.Forms.TextBox();
			this.labelFunc = new System.Windows.Forms.Label();
			this.labelYequals = new System.Windows.Forms.Label();
			this.btnPaint = new System.Windows.Forms.Button();
			this.btClear = new System.Windows.Forms.Button();
			this.mainMenu = new System.Windows.Forms.MainMenu();
			this.miFile = new System.Windows.Forms.MenuItem();
			this.miExit = new System.Windows.Forms.MenuItem();
			this.miAction = new System.Windows.Forms.MenuItem();
			this.miPaint = new System.Windows.Forms.MenuItem();
			this.miIncScale = new System.Windows.Forms.MenuItem();
			this.miDecScale = new System.Windows.Forms.MenuItem();
			this.miClear = new System.Windows.Forms.MenuItem();
			this.miHelp = new System.Windows.Forms.MenuItem();
			this.miAbout = new System.Windows.Forms.MenuItem();
			this.SuspendLayout();
			// 
			// panelGraph
			// 
			this.panelGraph.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
						| System.Windows.Forms.AnchorStyles.Left) 
						| System.Windows.Forms.AnchorStyles.Right)));
			this.panelGraph.BackColor = System.Drawing.Color.Gainsboro;
			this.panelGraph.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.panelGraph.Location = new System.Drawing.Point(8, 72);
			this.panelGraph.Name = "panelGraph";
			this.panelGraph.Size = new System.Drawing.Size(714, 416);
			this.panelGraph.TabIndex = 0;
			this.panelGraph.Paint += new System.Windows.Forms.PaintEventHandler(this.panelGraph_Paint);
			// 
			// tbFunc
			// 
			this.tbFunc.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
			this.tbFunc.Location = new System.Drawing.Point(40, 32);
			this.tbFunc.Name = "tbFunc";
			this.tbFunc.Size = new System.Drawing.Size(432, 23);
			this.tbFunc.TabIndex = 1;
			this.tbFunc.Text = "";
			// 
			// labelFunc
			// 
			this.labelFunc.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
			this.labelFunc.Location = new System.Drawing.Point(8, 8);
			this.labelFunc.Name = "labelFunc";
			this.labelFunc.Size = new System.Drawing.Size(304, 16);
			this.labelFunc.TabIndex = 2;
			this.labelFunc.Text = "Introduce the function:";
			// 
			// labelYequals
			// 
			this.labelYequals.Font = new System.Drawing.Font("Microsoft Sans Serif", 14F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
			this.labelYequals.Location = new System.Drawing.Point(8, 32);
			this.labelYequals.Name = "labelYequals";
			this.labelYequals.Size = new System.Drawing.Size(32, 24);
			this.labelYequals.TabIndex = 4;
			this.labelYequals.Text = "y=";
			// 
			// btnPaint
			// 
			this.btnPaint.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnPaint.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
			this.btnPaint.Location = new System.Drawing.Point(504, 24);
			this.btnPaint.Name = "btnPaint";
			this.btnPaint.Size = new System.Drawing.Size(104, 32);
			this.btnPaint.TabIndex = 5;
			this.btnPaint.Text = "Paint graph";
			this.btnPaint.Click += new System.EventHandler(this.btnPaint_Click);
			// 
			// btClear
			// 
			this.btClear.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btClear.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
			this.btClear.Location = new System.Drawing.Point(616, 24);
			this.btClear.Name = "btClear";
			this.btClear.Size = new System.Drawing.Size(104, 32);
			this.btClear.TabIndex = 6;
			this.btClear.Text = "Clear";
			this.btClear.Click += new System.EventHandler(this.btClear_Click);
			// 
			// mainMenu
			// 
			this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
						this.miFile,
						this.miAction,
						this.miHelp});
			// 
			// miFile
			// 
			this.miFile.Index = 0;
			this.miFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
						this.miExit});
			this.miFile.Text = "File";
			// 
			// miExit
			// 
			this.miExit.Index = 0;
			this.miExit.Text = "Exit";
			this.miExit.Click += new System.EventHandler(this.miExit_Click);
			// 
			// miAction
			// 
			this.miAction.Index = 1;
			this.miAction.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
						this.miPaint,
						this.miIncScale,
						this.miDecScale,
						this.miClear});
			this.miAction.Text = "Action";
			// 
			// miPaint
			// 
			this.miPaint.Index = 0;
			this.miPaint.Text = "Paint graph";
			this.miPaint.Click += new System.EventHandler(this.btnPaint_Click);
			// 
			// miIncScale
			// 
			this.miIncScale.Index = 1;
			this.miIncScale.Text = "Increase scale";
			this.miIncScale.Click += new System.EventHandler(this.miIncScale_Click);
			// 
			// miDecScale
			// 
			this.miDecScale.Index = 2;
			this.miDecScale.Text = "Decrease scale";
			this.miDecScale.Click += new System.EventHandler(this.miDecScale_Click);
			// 
			// miClear
			// 
			this.miClear.Index = 3;
			this.miClear.Text = "Clear";
			this.miClear.Click += new System.EventHandler(this.btClear_Click);
			// 
			// miHelp
			// 
			this.miHelp.Index = 2;
			this.miHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
						this.miAbout});
			this.miHelp.Text = "Help";
			// 
			// miAbout
			// 
			this.miAbout.Index = 0;
			this.miAbout.Text = "About";
			this.miAbout.Click += new System.EventHandler(this.miAbout_Click);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.LightGray;
			this.ClientSize = new System.Drawing.Size(730, 501);
			this.Controls.Add(this.btClear);
			this.Controls.Add(this.btnPaint);
			this.Controls.Add(this.labelYequals);
			this.Controls.Add(this.labelFunc);
			this.Controls.Add(this.tbFunc);
			this.Controls.Add(this.panelGraph);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu;
			this.Name = "MainForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Graph";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.Resize += new System.EventHandler(this.MainForm_Resize);
			this.ResumeLayout(false);
		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main()
		{
			Application.Run(new MainForm());
		}

		private void panelGraph_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			Pen penBlack = new Pen(Color.Black, 3);
			Graphics gr = e.Graphics;
			//vertical axis
			gr.DrawLine(penBlack, panelGraph.Width>>1, 0,
						panelGraph.Width>>1, panelGraph.Height);
			//horizontal axis
			gr.DrawLine(penBlack, 0, panelGraph.Height>>1,
						panelGraph.Width, panelGraph.Height>>1);

			//paint graphs if there're some
			foreach(string s in funcs) {
				paintGraph(s);
			}
		}
		
		private void MainForm_Resize(object sender, System.EventArgs e)
		{
			panelGraph.Refresh();
		}
		
		private void btnPaint_Click(object sender, System.EventArgs e)
		{
			paintGraph(tbFunc.Text);
		}

		private void btClear_Click(object sender, System.EventArgs e)
		{
			funcs.Clear();
			panelGraph.Refresh();
		}

		private void paintGraph(string s) {
			try {
				if(s.Length == 0) return;

				//convert to ppn
				Ppn ppn = new Ppn(s);
				ArrayList lxms = ppn.convert();
				if(!funcs.Contains(s))
					funcs.Add(s);

				//calculate and draw the graph
				CalcExpr cexpr = new CalcExpr();
				float prevX = 0, prevY = 0;        //previous coordinates
				float x, y = 0;                    //current coordinates
				bool paint = true;
				Graphics canvas = panelGraph.CreateGraphics();
				Matrix matrix = new Matrix(1, 0, 0, -1, 0, 0);
				matrix.Scale(scale.X, scale.Y);
				canvas.Transform = matrix;
				canvas.TranslateTransform(panelGraph.Width/2, panelGraph.Height/2,
										   MatrixOrder.Append);
				Pen pen = new Pen(Color.Black, 0.1F);

				unchecked {
					for(float i = -100; i<100; ++i) {
						Lxm res = cexpr.executeExpr(lxms, i);
						x = i;
						y = (float)res.num;
						if(i > -100 && res.type == "valid") {
							if(paint) {
								canvas.DrawLine(pen, prevX, prevY, x, y);
							}
							paint = true;
						}
						else paint = false;
						prevX = x;
						prevY = y;
					}
				}
			}
			catch(Exception exc) {
				MessageBox.Show(exc.Message);
			}
		}
		
		private void miExit_Click(object sender, System.EventArgs e)
		{
			Close();
		}
		
		private void miIncScale_Click(object sender, System.EventArgs e)
		{
			if(scale.X < 64 && scale.Y < 64) {
				scale.X *= 2;
				scale.Y *= 2;
			}
			panelGraph.Refresh();
		}
		
		private void miDecScale_Click(object sender, System.EventArgs e)
		{
			if(scale.X > 8 && scale.Y > 8) {
				scale.X /= 2;
				scale.Y /= 2;
			}
			panelGraph.Refresh();
		}
		
		private void miAbout_Click(object sender, System.EventArgs e)
		{
			FormAbout about = new FormAbout();
			about.Show();
		}
	}
}
